<?php /**
 * @file
 * Contains \Drupal\miniorange_saml\Controller\DefaultController.
 */

namespace Drupal\miniorange_saml\Controller;


use Drupal\user\Entity\User;
use Drupal\miniorange_saml\Utilities;
use Drupal\miniorange_saml\MiniOrangeAcs;
use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Response;
use Drupal\miniorange_saml\MiniOrangeAuthnRequest;
use Symfony\Component\HttpFoundation\RedirectResponse;

use Drupal\Core\Form\FormBuilder;
use Drupal\Core\Ajax\AjaxResponse;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Core\Ajax\OpenModalDialogCommand;
use Drupal\miniorange_saml\miniorange_saml_sp_registration;

/**
 * Default controller for the miniorange_saml module.
 */
class miniorange_samlController extends ControllerBase
{
    public function miniorange_saml_feedback_func()
    {
        $res = '';
        $res = json_encode($_POST);
        $outarr = json_decode($res, TRUE);
        $_SESSION['mo_other'] = "False";
        $reason = $outarr['reason'];
        $q_feedback = $outarr['q_feedback'];
        $message = 'Reason: ' . $reason . '<br>Feedback: ' . $q_feedback;
        $url = 'https://login.xecurify.com/moas/api/notify/send';
        $ch = curl_init($url);
        $email = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_email');
        if ( empty( $email ) ) {
            $email = $outarr['email'];
        }
        if ( \Drupal::service('email.validator')->isValid( $email ) ) {
            $phone = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_admin_phone');
            $customerKey = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_id');
            $apikey = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_customer_api_key');
            if ( $customerKey == '' ) {
                $customerKey = "16555";
                $apikey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";
            }
            $currentTimeInMillis = self::get_oauth_timestamp();
            $stringToHash = $customerKey . $currentTimeInMillis . $apikey;
            $hashValue = hash("sha512", $stringToHash);
            $customerKeyHeader = "Customer-Key: " . $customerKey;
            $timestampHeader = "Timestamp: " . $currentTimeInMillis;
            $authorizationHeader = "Authorization: " . $hashValue;
            $fromEmail = $email;
            $subject = "Drupal 8 SAML SP Free Module Feedback";
            $query = '[Drupal 8 SAML SP Free]: ' . $message;
            $content = '<div >Hello, <br><br>Company :<a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>Phone Number :' . $phone . '<br><br>Email :<a href="mailto:' . $fromEmail . '" target="_blank">' . $fromEmail . '</a><br><br>Query :' . $query . '</div>';
            $fields = array(
                'customerKey' => $customerKey,
                'sendEmail' => true,
                'email' => array(
                    'customerKey' => $customerKey,
                    'fromEmail' => $fromEmail,
                    'fromName' => 'miniOrange',
                    'toEmail' => 'drupalsupport@xecurify.com',
                    'toName' => 'drupalsupport@xecurify.com',
                    'subject' => $subject,
                    'content' => $content
                ),
            );

            $field_string = json_encode($fields);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_ENCODING, "");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_AUTOREFERER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);    # required for https urls
            curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", $customerKeyHeader,
                $timestampHeader, $authorizationHeader));
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);
            $content = curl_exec($ch);
            if (curl_errno($ch)) {
                return json_encode(array("status" => 'ERROR', 'statusMessage' => curl_error($ch)));
            }
            curl_close($ch);
        }
        return new Response();
    }

    /**
     * This function is used to get the timestamp value
     */
    public function get_oauth_timestamp()
    {
        $url = 'https://login.xecurify.com/moas/rest/mobile/get-timestamp';
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_ENCODING, "");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_AUTOREFERER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); // required for https urls
        curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
        curl_setopt($ch, CURLOPT_POST, true);
        $content = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error in sending curl Request';
            exit ();
        }
        curl_close($ch);
        if (empty($content)) {
            $currentTimeInMillis = round(microtime(true) * 1000);
            $currentTimeInMillis = number_format($currentTimeInMillis, 0, '', '');
        }
        return empty($content) ? $currentTimeInMillis : $content;
    }

    public function uninst_mod() {
        global $base_url;
        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->clear('miniorange_saml_feedback')->save();
        \Drupal::service('module_installer')->uninstall(['miniorange_saml']);
        $uninstall_redirect = $base_url . '/admin/modules';
        $response = new RedirectResponse($uninstall_redirect);
        $response->send();
        return new Response();
    }


    public function saml_login() {
        global $base_url;
        $issuer =  $base_url;
        $relay_state = $base_url;
        $acs_url = $base_url . '/samlassertion';
        $sso_url = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_login_url');
        $nameid_format = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_nameid_format');
        $authn_request = new MiniOrangeAuthnRequest();
        $redirect = $authn_request->initiateLogin( $acs_url, $sso_url, $issuer, $nameid_format, $relay_state );
        $response = new RedirectResponse( $redirect );
        $response->send();
        return new Response();
    }

    public function saml_response() {
        global $base_url;
        $acs_url = $base_url . '/samlassertion';
        $cert_fingerprint = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_x509_certificate');
        $issuer = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_issuer');
        $sp_entity_id = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_sp_issuer');

        $username_attribute = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_email_attribute');

        if ( isset( $_GET['SAMLResponse'] ) ) {
            session_destroy();
            global $base_url;
            $response = new RedirectResponse($base_url);
            $response->send();
            return new Response();
        }
        $attrs = array();
        $role = array();
        $response_obj = new MiniOrangeAcs();
        $response = $response_obj->processSamlResponse($_POST, $acs_url, $cert_fingerprint, $issuer, $base_url, $sp_entity_id, $username_attribute, $attrs, $role);

        $account = user_load_by_mail( $response['username'] );

        // Create user if not already present.
        if ( $account == NULL ) {

            $random_password = user_password(8);
            $new_user = [
                'name' => $response['username'],
                'mail' => $response['email'],
                'pass' => $random_password,
                'status' => 1,
            ];
            // user_save() is now a method of the user entity.
            $account = User::create( $new_user );
            $account->save();

            $enable_roleMapping = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_enable_rolemapping');

            if ( $enable_roleMapping ) {
                /**
                 * Getting machine names of the roles.
                 */
                $roles_with_machine_name = \Drupal::entityTypeManager()->getStorage('user_role')->loadMultiple();
                $roles_with_machine_name_array = array();
                foreach ( $roles_with_machine_name as $key => $values ) {
                    $roles_with_machine_name_array[$key] = strtolower( $values->label() );
                }

                /**
                 * Get machine name of the default role. (eg. Authenticated User(role) = authenticated(machine name))
                 */
                $default_role = \Drupal::config('miniorange_saml.settings')->get( 'miniorange_saml_default_role' );
                foreach ( $roles_with_machine_name_array as $machine_name => $role_name ) {
                    if ( $role_name == strtolower( $default_role ) ) {
                        $default_role_value = $machine_name;
                    }
                }

                /**
                 * Assign default role for user is default role is other than AUTHENTICATED USER.
                 */
                if ( isset( $default_role_value ) && $default_role_value != 'authenticated' ) {
                    $account->addRole( $default_role_value );
                    $account->save();
                }
            }
        }

        if ( user_is_blocked($response['username'] ) == FALSE) {
            $rediectUrl = $base_url;
            if ( array_key_exists('relay_state', $response) && !empty( trim($response['relay_state']) ) ) {
                $rediectUrl = $response['relay_state'];
            }
            $_SESSION['sessionIndex'] = $response['sessionIndex'];
            $_SESSION['NameID'] = $response['NameID'];
            $_SESSION['mo_saml']['logged_in_with_idp'] = TRUE;
            user_login_finalize($account);
           
            $response = new RedirectResponse( $rediectUrl );
            $response->send();
            return new Response();
        }else {
            $error = 'User Blocked By Administrator.';
            $message = 'Please Contact your administrator.';
            $cause = 'This user account is not allowed to login.';
            Utilities::showErrorMessage($error, $message, $cause);
            return new Response();
        }
    }

    /**
     * Test configuration callback
     */

    function test_configuration()
    {
        global $base_url;
        $sendRelayState = "testValidate";
        $ssoUrl = \Drupal::config('miniorange_saml.settings')->get("miniorange_saml_idp_login_url");
        $acsUrl = $base_url . "/samlassertion";
        $nameid_format = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_nameid_format');
        $issuer = $base_url;
        $samlRequest = Utilities::createAuthnRequest($acsUrl, $issuer, $nameid_format, FALSE);
        $redirect = $ssoUrl;
        if (strpos($ssoUrl, '?') !== FALSE) {
            $redirect .= '&';
        } else {
            $redirect .= '?';
        }
        $redirect .= 'SAMLRequest=' . $samlRequest . '&RelayState=' . urlencode($sendRelayState);
        $response = new RedirectResponse($redirect);
        $response->send();
        return new Response();
    }

    function saml_request()
    {
        global $base_url;
        $sso_url = \Drupal::config('miniorange_saml.settings')->get("miniorange_saml_idp_login_url");
        $acs_url = $base_url . "/showSAMLrequest";
        $samlRequestXML = Utilities::createSAMLRequest($acs_url, $base_url, $sso_url);
        $sendRelayState = "displaySAMLRequest";
        Utilities::Print_SAML_Request($samlRequestXML, $sendRelayState);
        return;
    }

    function saml_response_generator()
    {
        global $base_url;
        $sendRelayState = "showSamlResponse";
        $ssoUrl = \Drupal::config('miniorange_saml.settings')->get("miniorange_saml_idp_login_url");
        $acsUrl = $base_url . "/samlassertion";
        $issuer = $base_url;
        $nameid_format = \Drupal::config('miniorange_saml.settings')->get("miniorange_nameid_format");
        $samlRequest = Utilities::createAuthnRequest($acsUrl, $issuer, $nameid_format, FALSE);
        $redirect = $ssoUrl;
        if (strpos($ssoUrl, '?') !== false) {
            $redirect .= '&';
        } else {
            $redirect .= '?';
        }
        $redirect .= 'SAMLRequest=' . $samlRequest . '&RelayState=' . urlencode($sendRelayState);
        $response = new RedirectResponse($redirect);
        $response->send();
        return new Response();
    }
    function saml_metadata(){

        global $base_url;
        $entity_id = $base_url;
        $acs_url   = $base_url . '/samlassertion';
        $header    = isset($_REQUEST['download']) && boolval($_REQUEST['download']) ? 'Content-Disposition: attachment; filename="Metadata.xml"' : 'Content-Type: text/xml';
        header($header);
        echo '<?xml version="1.0"?>
                <md:EntityDescriptor xmlns:md="urn:oasis:names:tc:SAML:2.0:metadata" validUntil="2020-10-28T23:59:59Z" cacheDuration="PT1446808792S" entityID="' . $entity_id . '">
                  <md:SPSSODescriptor AuthnRequestsSigned="false" WantAssertionsSigned="true" protocolSupportEnumeration="urn:oasis:names:tc:SAML:2.0:protocol">
                    <md:NameIDFormat>urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified</md:NameIDFormat>
                    <md:AssertionConsumerService Binding="urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST" Location="' . $acs_url . '" index="1"/>
                  </md:SPSSODescriptor>
                  <md:Organization>
                    <md:OrganizationName xml:lang="en-US">miniOrange</md:OrganizationName>
                    <md:OrganizationDisplayName xml:lang="en-US">miniOrange</md:OrganizationDisplayName>
                    <md:OrganizationURL xml:lang="en-US">http://miniorange.com</md:OrganizationURL>
                  </md:Organization>
                  <md:ContactPerson contactType="technical">
                    <md:GivenName>miniOrange</md:GivenName>
                    <md:EmailAddress>info@xecurify.com</md:EmailAddress>
                  </md:ContactPerson>
                  <md:ContactPerson contactType="support">
                    <md:GivenName>miniOrange</md:GivenName>
                    <md:EmailAddress>info@xecurify.com</md:EmailAddress>
                  </md:ContactPerson>
                </md:EntityDescriptor>';
        exit;
    }
        public function miniorange_saml_register(){
        $payment_plan = isset($_GET['payment_plan']) ? $_GET['payment_plan'] : '';
        \Drupal\miniorange_saml\miniorange_saml_sp_registration::miniorange_saml_register_popup($payment_plan);
        return new Response();
    }

    public function miniorange_saml_close_registration(){
        Utilities::saml_back(true);
        return new Response();
    }

}